Index: trunk/expressoMail1_2/inc/class.exporteml.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.exporteml.inc.php	(revision 5079)
+++ trunk/expressoMail1_2/inc/class.exporteml.inc.php	(revision 5134)
@@ -17,12 +17,4 @@
 	var $tempDir;
 	
-	
-	/**
-	* Construtor da classe ExportEml
-	*
-	* @license    http://www.gnu.org/copyleft/gpl.html GPL
-	* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-	* @sponsor    Caixa Econômica Federal
-	*/
 	function ExportEml() {
 	   
@@ -303,19 +295,17 @@
     }
 
+    function export_eml( $params ){
+
+	return $this->export_msg_data( $params['msgs_to_export'],
+				       $params['folder'] );
+    }
+
 	function export_msg($params) {
-		$this-> folder = $params['folder'];
-		$this->folder = mb_convert_encoding($this->folder, "UTF7-IMAP","ISO_8859-1");
-		$id_number = $params['msgs_to_export'];
 		$tempDir = $this->tempDir;
-		$this->connectImap();
-		$header	 	= $this-> getHeader($id_number);
-		$body		= $this-> getBody($id_number);
-		
 		$file = "source_".$_SESSION[ 'phpgw_session' ][ 'session_id' ].".php";
 		$f = fopen($tempDir.'/'.$file,"w");
-		fputs($f,$header ."\r\n\r\n". $body);
+		fputs($f, $this->export_msg_data( $params['msgs_to_export'], $params['folder'] ) );
 		fclose($f);
 		
-		imap_close($this->mbox_stream);
 		return $tempDir.'/'.$file;
 	}
@@ -336,7 +326,6 @@
 
 		function export_to_archive($id_msg,$folder) {
-		$this-> folder = $folder; 
+		$this->folder = $folder;
  		$this->folder = mb_convert_encoding($this->folder, "UTF7-IMAP","ISO_8859-1");
- 	           
  		$tempDir = $this->tempDir;
  		                 
@@ -344,74 +333,17 @@
  		$header         = $this-> getHeader($id_msg); 
  		$body           = $this-> getBody($id_msg); 
- 		$name = md5($_SESSION[ 'phpgw_session' ][ 'session_id' ].microtime());
  		
-		//$file = $_SESSION[ 'phpgw_session' ][ 'session_id' ].$name;
- 		$file = "source_".$_SESSION[ 'phpgw_session' ][ 'session_id' ]."_".time().".php"; //source_[sessao]_[timestamp].php 
-		$f = fopen($tempDir . '/'.$file,"w");
- 		fputs($f,utf8_encode($header) ."\r\n\r\n". utf8_encode($body));
+		$file = tempnam ($tempDir, 'source_#'.$id_msg);
+		$file .= '.php';
+		$fileName = basename ($file);
+		$f = fopen($file, "w");
+		fputs($f,$phpheader.$header ."\r\n\r\n". $body);
  		fclose($f); 
+		$urlPath = 'tmpLclAtt/' . $fileName;
  		                 
  		imap_close($this->mbox_stream); 
 		return "inc/gotodownload.php?idx_file=".$tempDir . '/'.$file."&newfilename=fonte_da_mensagem.txt";
+        }
  		                 
-        }
-
-	function get_attachments_in_array($params) {
-		$return_attachments = array();
-
-		$id_number = $params['num_msg'];		
-		$attachments =unserialize(rawurldecode($params['s_attachments']));
-		
-		$tempDir = dirname( __FILE__ ) . '/../tmpLclAtt';
-		$tempSubDir = md5(microtime());
-		exec('mkdir ' . $tempDir . '/'.$tempSubDir.'; cd ' . $tempDir . '/'.$tempSubDir);
-		
-		$this-> folder = $params['folder'];
-		$this->folder = mb_convert_encoding($this->folder, "UTF7-IMAP","UTF-8");
-		$this->connectImap();
-
-		include_once("class.imap_attachment.inc.php");
-
-		$imap_attachment = new imap_attachment();
-		$attachments = $imap_attachment->download_attachment($this->mbox_stream, $id_number);
-		foreach($attachments as $i => $attachment){
-			if($i && $i == 'names')
-				continue;
-			$fileNameReal = $this->remove_accents($attachment['name']);
-			$ContentType = $this->getFileType($fileNameReal);
-			$fileName = $fileNameReal . ".php";
-			$f = fopen($tempDir . '/'.$tempSubDir.'/'.$fileName,"wb");
-			if(!$f)
-				return $tempDir . '/'.$tempSubDir.'/'.$fileName;			
-
-			$fileContent = imap_fetchbody($this->mbox_stream, $id_number,$attachment['pid'], FT_UID);
-			$urlPath = 'tmpLclAtt/'.$tempSubDir.'/'.$fileName;
-			
-			$headers = "<?php header('Content-Type: ".$ContentType."');
-				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
-				header('Pragma: public');
-				header('Expires: 0'); // set expiration time
-	 	 		header('Content-Disposition: attachment; filename=\"". addslashes($fileNameReal) ."\"');\n echo ";
-			
-			if($attachment['encoding'] == 'base64') {
-				$headers.=" imap_base64('".$fileContent."');?>";
-			}
-			else if($attachment['encoding'] == 'quoted_printable_decode') {
-				$headers.=" quoted_printable_decode('".$fileContent."');?>";
-			}
-			else {
-				$headers.=" '".$fileContent."';?>";
-			}
-			
-			fputs($f,$headers);
-
-			array_push($return_attachments,array('name' => $fileName,'url' => $urlPath,'pid' =>$attachment['pid']));
-			fclose($f);
-		}
-		imap_close($this->mbox_stream);
-		return $return_attachments;
-        }
-
-
 	function remove_accents($string) {
 		/*
@@ -423,7 +355,52 @@
 			"áàâãäéèêëíìîïóòôõöúùûüç?\"'!@#$%š&*()-=+Ž`[]{}~^,<>;:/?\\|¹²³£¢¬§ªº°ÁÀÂÃÄÉÈÊËÍÌÎÏÓÒÔÕÖÚÙÛÜÇ",
 			"aaaaaeeeeiiiiooooouuuuc___________________________________________AAAAAEEEEIIIIOOOOOUUUUC");
-	}
-	
-
+        }
+
+	function get_attachments_headers( $folder, $id_number ){
+
+	    $this->folder = mb_convert_encoding($folder, "UTF7-IMAP","UTF-8");
+		
+	    $return_attachments = array();
+		
+	    include_once("class.attachment.inc.php");
+
+	    $imap_attachment = new attachment();
+	    $imap_attachment->setStructureFromMail( $folder, $id_number );
+	    $attachments = $imap_attachment->getAttachmentsInfo();
+
+		foreach($attachments as $i => $attachment){
+
+		    $fileContent = $imap_attachment->getAttachment( $attachment['pid'] );
+			
+		    $headers = "<?php header('Content-Type: {$attachment['type']}');
+				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
+				header('Pragma: public');
+				header('Expires: 0'); // set expiration time
+				      header('Content-Disposition: attachment; filename=\"{$attachment['name']}\"');\n
+				      echo '$fileContent';?>";
+			
+		    $return_attachments[ $attachment['name'] ] = array( "content" => $headers, "pid" => $attachment['pid'] );
+			}
+
+	    return( $return_attachments );
+			}
+			
+	function get_attachments_in_array($params) {
+		$return_attachments = array();
+
+		$attachments = $this->get_attachments_headers( $params['folder'], $params['num_msg'] );
+
+		if( !empty( $attachments ) )
+		{
+		    foreach($attachments as $fileNameReal => $attachment){
+
+			    array_push($return_attachments,array('name' => $fileNameReal, 'pid' =>$attachment['pid'], 'contentType' => $this->getFileType( $fileNameReal  ) ));
+		}
+        }
+
+		return $return_attachments;
+
+	}
+	
 	private function getFileType($nameFile) {
 		$strFileType = strrev(substr(strrev(strtolower($nameFile)),0,4));
@@ -529,4 +506,6 @@
 	   	if ($strFileType == ".eml")
 	   		$ContentType = "text/plain";
+		if ($strFileType == ".png")
+			$ContentType = "image/png";
 		return $ContentType;
 	}
@@ -534,7 +513,9 @@
 	function download_all_attachments($params) {
 		
+		require_once $_SESSION['rootPath'].'/expressoMail1_2/inc/class.attachment.inc.php';
+		$atObj = new attachment();
+		$atObj->setStructureFromMail($params['folder'],$params['num_msg']);
+		$attachments = $atObj->getAttachmentsInfo();
 		$id_number = $params['num_msg'];		
-		$attachments =unserialize(rawurldecode($params['s_attachments']));
-		
 		$tempDir = $this->tempDir;
 		$tempSubDir = $_SESSION['phpgw_session']['session_id'];
@@ -543,8 +524,4 @@
 		$this-> folder = $params['folder'];
 		$this->folder = mb_convert_encoding($this->folder, "UTF7-IMAP","UTF-8");
-		$this->connectImap();
-		include("class.imap_attachment.inc.php");
-		$imap_attachment = new imap_attachment();
-		$attachments = $imap_attachment->download_attachment($this->mbox_stream, $id_number);
 		
 		$fileNames = Array();
@@ -583,9 +560,5 @@
 			if(!$f)
 				return False;			
-						
-			$fileContent = imap_fetchbody($this->mbox_stream, $id_number,$attachments[$i]['pid'], FT_UID);
-			if($attachments[$i]['encoding'] == 'base64')
-				fputs($f,imap_base64($fileContent));
-			else		
+			$fileContent = $atObj->getAttachment( $attachments[$i]['pid'] );	
 				fputs($f,$fileContent);
 				
Index: trunk/expressoMail1_2/inc/class.dynamic_contacts.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.dynamic_contacts.inc.php	(revision 1059)
+++ trunk/expressoMail1_2/inc/class.dynamic_contacts.inc.php	(revision 5134)
@@ -79,5 +79,5 @@
 			{
 				foreach($this->contacts as $item => $valor)
-					$contact .= ';'.$this->contacts[$item]['email'] . ',';
+					$contact .= str_replace("#",";",$this->contacts[$item]['email']) . ',';
 				//Retira ultima virgula.
 				$contact = substr($contact,0,(strlen($contact) - 1));
@@ -106,5 +106,5 @@
 		{
 			// Trim all whitespaces and duplicated commas from full_email_address
-			$full_email_address = preg_replace('{(,)\1+}',',',ereg_replace( ' +', '', $full_email_address));
+			$full_email_address = preg_replace('{(,)\1+}',',',$full_email_address);
 			$parse_address = imap_rfc822_parse_adrlist($full_email_address, "");
 			$new_contacts = array();
@@ -118,7 +118,7 @@
 				if(!$this->contacts) // Used one time to insert the first contact in database
 				{
-					$this->db->insert_contact($val->mailbox."@".$val->host);
+					$this->db->insert_contact($val->personal."#".$val->mailbox."@".$val->host);
 					// Just new contact added.
-					$new_contacts[] = $val->mailbox."@".$val->host;
+					$new_contacts[] = $val->personal.";".$val->mailbox."@".$val->host; 
 					$this->contacts = $this->db->get_dynamic_contacts();
 				}
@@ -129,5 +129,5 @@
 					foreach($this->contacts as $item => $valor)
 					{
-						if($this->contacts[$item]['email'] == $val->mailbox."@".$val->host) // check if email already exists
+						if($this->contacts[$item]['email'] == $val->personal."#".$val->mailbox."@".$val->host) // check if email already exists
 						{	
 							$this->contacts[$item]['timestamp'] = time(); //update timestamp of email
@@ -143,14 +143,14 @@
 					{
 						// Just new contact added.
-						$new_contacts[] = $val->mailbox."@".$val->host;
+						$new_contacts[] = $val->personal.";".$val->mailbox."@".$val->host;
 						if($this->number_of_contacts > count($this->contacts))
 						{
 							$this->contacts[] = array( 'timestamp'	=> time(),
-														'email'		=> $val->mailbox."@".$val->host);
+														'email'         => $val->personal."#".$val->mailbox."@".$val->host);
 						}
 						if($this->number_of_contacts <= count($this->contacts))
 						{
 							$this->contacts[$older_contact] = array( 'timestamp'	=> time(),
-																		'email'		=> $val->mailbox."@".$val->host);
+																		'email'         => $val->personal."#".$val->mailbox."@".$val->host);
 						}
 					}
Index: trunk/expressoMail1_2/inc/gotodownload.php
===================================================================
--- trunk/expressoMail1_2/inc/gotodownload.php	(revision 4842)
+++ trunk/expressoMail1_2/inc/gotodownload.php	(revision 5134)
@@ -50,6 +50,4 @@
 	$newfilename = $newfilename ? $newfilename 	: $filename;
 	$strFileType = strrev(substr(strrev(strtolower($filename)),0,4));
-	if(strpos($strFileType ,"." )===false) 
- 		$strFileType = strrev(substr(strrev(strtolower($newfilename)),0,4)); 
 
 	downloadFile($strFileType, $filename, $newfilename, $fileContent, $encoding);
Index: trunk/expressoMail1_2/inc/class.ScriptS.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.ScriptS.inc.php	(revision 4986)
+++ trunk/expressoMail1_2/inc/class.ScriptS.inc.php	(revision 5134)
@@ -215,26 +215,11 @@
 
     function convert_specialchar($input) {
-        $special_char = false;
-        for ($i = 0; $i < strlen($input); $i++) {
-            if (preg_match('/[^a-z0-9.@~_+=&\'*^\ \-\[\]]/i', $input[$i])) {
-                $special_char = true;
-                $input = preg_replace('/\\' . $input[$i] . '/', '=' . bin2hex($input[$i]), $input);
-            }
-        }
-
-        if ($special_char) {
-            /*             *
-             * When using arrays with pattern and replacement,
-             * the keys are processed in the order they appear in the array.
-             * See preg_replace in php.net/preg_replace
-             * */
-            $patterns[0] = '/=c3/i';
-            $patterns[1] = '/ /';
-            $replacements[1] = '';
+	$temp_input = $input;  
+	$temp_input = imap_8bit($temp_input); 
+
+	$patterns[0] = '/ /'; 
             $replacements[0] = '_';
-            $input = preg_replace($patterns, $replacements, $input);
-        }
-
-        return($input);
+	$temp_input = preg_replace($patterns, $replacements, $temp_input);  
+	return ($temp_input);
     }
 
@@ -522,5 +507,5 @@
         // Lê as regras fora do escritório;
         if ($this->newout != "") {
-            $newscriptfoot .= preg_replace("/[\\n\\r]/", "%0A", $this->newout) . "\n";
+            $newscriptfoot .= preg_replace("/[\\n\\r]/", " ", $this->newout) . "\n";
         }
         $newscriptfoot .= "#mode&&basic\n";
Index: trunk/expressoMail1_2/inc/class.attachment.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.attachment.inc.php	(revision 5079)
+++ trunk/expressoMail1_2/inc/class.attachment.inc.php	(revision 5134)
@@ -32,19 +32,11 @@
      * @param integer $msgNumber Imap menssagem number
      */
-    function attachment($rootPath = false)
+    function attachment()
     {
         /*
          * Requires
          */
-        if($rootPath)
-        {
-            require_once $rootPath.'/library/mime/mimePart.php';
-            require_once $rootPath.'/library/mime/mimeDecode.php';
-        }
-        else
-        {
             require_once $_SESSION['rootPath'].'/library/mime/mimePart.php';
             require_once $_SESSION['rootPath'].'/library/mime/mimeDecode.php';
-        }
         //----------------------------------------------------------//
 
@@ -52,4 +44,7 @@
         $this->decodeConf['decode_bodies']  = true;
         $this->decodeConf['decode_headers'] = true;
+	
+	if( array_key_exists('nested_messages_are_shown', $_SESSION['phpgw_info']['user']['preferences']['expressoMail']) && ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['nested_messages_are_shown'] == '1'))
+	    $this->decodeConf['rfc_822bodies']  = true;
     }
     //----------------------------------------------------------------------------//
@@ -86,4 +81,10 @@
         $this->structure = $decoder->decode($this->decodeConf);
 
+		//TODO: Descartar código após atualização do módulo de segurança da SERPRO 
+		if($this->isSignedMenssage()) 
+			$this->convertSignedMenssage($rawMessageData); 
+		//////////////////////////////////////////////////////
+			
+			
         /*
          * Clean memory and close imap connection
@@ -95,4 +96,52 @@
     }
 
+	//TODO: Descartar código após atualização do módulo de segurança da SERPRO 
+	private function isSignedMenssage() 
+ 	{ 
+		if(strtolower($this->structure->ctype_primary) == 'application' && strtolower($this->structure->ctype_secondary) == 'x-pkcs7-mime' ) 
+			return true; 
+		else 
+			return false;      
+	} 
+    //////////////////////////////////////////////////////////////////////////
+
+   //TODO: Descartar código após atualização do módulo de segurança da SERPRO 
+   private function convertSignedMenssage($rawMessageData) 
+	{ 
+		$decoder = new Mail_mimeDecode($this->extractSignedContents($rawMessageData)); 
+		$this->structure = $decoder->decode($this->decodeConf);          
+	} 
+	///////////////////////////////////////////////////////////////////////////
+	
+	//TODO: Descartar código após atualização do módulo de segurança da SERPRO 
+	private function extractSignedContents( $data ) 
+ 		    { 
+ 		        $pipes_desc = array( 
+ 		            0 => array('pipe', 'r'), 
+ 		            1 => array('pipe', 'w') 
+ 		        ); 
+ 		 
+ 		        $fp = proc_open( 'openssl smime -verify -noverify -nochain', $pipes_desc, $pipes); 
+ 		        if (!is_resource($fp)) { 
+ 		           return false; 
+ 		        } 
+ 		 
+ 		        $output = ''; 
+ 		 
+ 		        /* $pipes[0] => writeable handle connected to child stdin 
+ 		           $pipes[1] => readable handle connected to child stdout */ 
+ 		        fwrite($pipes[0], $data); 
+ 		        fclose($pipes[0]); 
+ 		 
+ 		        while (!feof($pipes[1])) { 
+ 		            $output .= fgets($pipes[1], 1024); 
+ 		        } 
+ 		        fclose($pipes[1]); 
+ 		        proc_close($fp); 
+ 		 
+ 		        return $output; 
+ 		    } 
+	/////////////////////////////////////////////////////////////////////////////////////
+	
     /**
      * Set Stucture from Mail_mimeDecode Structure
@@ -116,4 +165,9 @@
         $decoder = new Mail_mimeDecode($rawMail);
         $this->structure = $decoder->decode($this->decodeConf);
+		
+		//TODO: Descartar código após atualização do módulo de segurança da SERPRO 
+		if($this->isSignedMenssage()) 
+			$this->convertSignedMenssage($rawMessageData);  
+		//////////////////////////////////////////////////////////////////////////
     }
 
@@ -169,5 +223,5 @@
         $attachment = array();
         $this->_getPartInfo($this->structure,$partNumber,$attachment);
-        return $attachment;
+        return $attachment[0];
     }
 
@@ -180,5 +234,9 @@
     private function _getRaw()
     {
-        return imap_fetchheader($this->mbox, $this->msgNumber, FT_UID).imap_body($this->mbox, $this->msgNumber, FT_UID);
+			/* 
+ 	         * Chamada original imap_fetchheader($this->mbox, $this->msgNumber, FT_UID)."\r\n".imap_body($this->mbox, $this->msgNumber, FT_UID); 
+ 	         * Inserido replace para corrigir um bug que acontece raramente em mensagens vindas do outlook com muitos destinatarios 
+ 	         */ 
+ 	        return str_replace("\r\n\t", '', imap_fetchheader($this->mbox, $this->msgNumber, FT_UID))."\r\n".imap_body($this->mbox, $this->msgNumber, FT_UID);
     }
 
@@ -202,10 +260,10 @@
                 else
                 {
-                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
+                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts) && $this->decodeConf['rfc_822bodies'] !== true )
                             $this->_getPartContent($part,$soughtIndex,$body,$pIndex.'.'.$index);
                     else
                     {
                         $currentIndex = $pIndex.'.'.$index;
-                        if($currentIndex == $soughtIndex)
+                        if($currentIndex === $soughtIndex)
                         {
                             $body = $part->body;
@@ -235,10 +293,10 @@
                 else
                 {
-                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
+                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts) && $this->decodeConf['rfc_822bodies'] !== true)
                          $this->_getPartInfo($part,$soughtIndex,$info,$pIndex.'.'.$index);
                     else
                     {
                         $currentIndex = $pIndex.'.'.$index;
-                        if($currentIndex == $soughtIndex)
+                        if($currentIndex === $soughtIndex)
                         {
 							$this->_pushAttachmentsInfo($part,$info,$currentIndex);
@@ -262,5 +320,5 @@
     {
 
-        if($structure->parts)
+        if(isset($structure->parts))
         {
             foreach ($structure->parts  as $index => $part)
@@ -270,5 +328,5 @@
                 else
                 {
-                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
+                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts) && $this->decodeConf['rfc_822bodies'] !== true)
                        $this->_getAttachmentsInfo($part,$attachments,$pIndex.'.'.$index);
                     else
@@ -293,19 +351,46 @@
 	/**
 	* Write in $$attachments, array with the information of attachment 
-	*
-	* @license    http://www.gnu.org/copyleft/gpl.html GPL
-	* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-	* @sponsor    Caixa Econômica Federal
-	* @param      $structure
-	* @param      $attachments
-	* @param      $pIndex
+ 	* @param <type> $structure 
+ 	* @param <type> $attachments 
+ 	* @param <type> $pIndex 
 	*/	
  	private function _pushAttachmentsInfo(&$structure, &$attachments, $pIndex = '0') 
  	{ 
- 		        $name = false; 
- 		        if($structure->d_parameters['filename']) $name = $structure->d_parameters['filename']; 
- 		        else if($structure->ctype_parameters['name']) $name = $structure->ctype_parameters['name']; 
+			$name = '';                                
+ 		        if((isset($structure->d_parameters['filename']))&& ($structure->d_parameters['filename'])) $name = $structure->d_parameters['filename']; 
+ 		        else if((isset($structure->ctype_parameters['name']))&&($structure->ctype_parameters['name'])) $name = $structure->ctype_parameters['name'];
  		        else if(strtolower($structure->ctype_primary) == 'text' &&  strtolower($structure->ctype_secondary) == 'calendar') $name = 'calendar.ics'; 
  		 
+                            //Attachments com nomes grandes são quebrados em varias partes VER RFC2231
+                            if( !$name && isset($structure->disposition) && (strtolower($structure->disposition) === 'attachment' || strtolower($structure->ctype_primary) == 'image'))
+					foreach ($structure->d_parameters as $i => $v)
+						if(strpos($i , 'filename') !== false)
+							$name .= urldecode(str_ireplace(array('ISO-8859-1','UTF-8','US-ASCII'),'',$v));
+			     if( !$name && isset($structure->disposition) && (strtolower($structure->disposition) === 'attachment' || strtolower($structure->ctype_primary) == 'image') )
+					foreach ($structure->ctype_parameters as $i => $v)
+						if(strpos($i , 'name') !== false)
+							$name .= urldecode(str_ireplace(array('ISO-8859-1','UTF-8','US-ASCII'),'',$v));		
+			   ////////////////////////////////////////////////////////////////////////////////////
+						
+
+                        if($structure->ctype_primary == 'message') {
+                                $attach = new attachment();
+                                $attach->setStructureFromRawMail($structure->body);
+
+                                if (!$name)
+                                        $name = ($attach->structure->headers['subject']) ? $attach->structure->headers['subject'] : 'no title';
+
+                                if (!preg_match("/\.eml$/", $name))
+                                        $name .= '.eml';
+                        }		                               
+
+                        if(!$name && strtolower($structure->ctype_primary) == 'image')
+                        {
+                            if(strlen($structure->ctype_secondary) === 3)
+                                $ext = strtolower($structure->ctype_secondary);
+
+                            $name = 'Embedded-Image.'.$ext;
+                        }
+				
  		        if($name) 
  		        { 
@@ -316,4 +401,5 @@
  		            $definition['name'] = addslashes(mb_convert_encoding($name, "ISO-8859-1")); 
  		            $definition['encoding'] = $structure->headers['content-transfer-encoding']; 
+                            $definition['type'] = strtolower($structure->ctype_primary).'/'.strtolower($structure->ctype_secondary);                                       
  		            $definition['fsize'] = mb_strlen($structure->body, $structure->headers['content-transfer-encoding']); 
  		 
@@ -334,4 +420,5 @@
      private function _getEmbeddedImagesInfo($structure, &$images, $pIndex = '0')
      {
+		if(isset($structure->parts))
         foreach ($structure->parts  as $index => $part)
         {
@@ -340,20 +427,30 @@
             else
             {
-                if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
+                if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts) && $this->decodeConf['rfc_822bodies'] !== true)
                         $this->_getEmbeddedImagesInfo($part,$images,$pIndex.'.'.$index);
                 else
                 {
-                    if(!$part->ctype_parameters['name'])
+                    if(is_array($part->ctype_parameters) && !array_key_exists('name', $part->ctype_parameters))
+                        if(isset($part->d_parameters['filename']))
                          $name = $part->d_parameters['filename'];
                     else
+                          $name = null;
+                    else
                          $name = $part->ctype_parameters['name'];
 
-                    $type =  strtolower(substr($name, -4));
+                    if($name && (strlen($name) - (strrpos($name, '.')+1) === 3 )) 
+                        $ext = strtolower(substr ( $name , (strrpos($name, '.')+1) ));		
+                    else if(strlen($structure->ctype_secondary) === 3)
+                        $ext = strtolower($structure->ctype_secondary);
+                    
+                    if(!$name && strtolower($structure->ctype_primary) == 'image') $name = 'Embedded-Image.'.$ext;
+					
                     $ctype = strtolower($part->ctype_primary.'/'.$part->ctype_secondary);
-                    if(strtolower($part->ctype_primary) == 'image' ||  ($ctype == 'application/octet-stream' && ($type == '.png' || $type == '.jpg' || $type == '.gif')))
+        
+                    if(strtolower($part->ctype_primary) == 'image' ||  ($ctype == 'application/octet-stream' && ($ext == 'png' || $ext == 'jpg' || $ext == 'gif' || $ext == 'bmp' || $ext == 'tif')))
                     {
                         $definition['pid'] = $pIndex.'.'.$index;
                         $definition['name'] = addslashes($name);
-                        $definition['type'] = 'image/'.strtolower($part->ctype_secondary);
+                        $definition['type'] = $ctype;
                         $definition['encoding'] = $part->headers['content-transfer-encoding'];
                         $definition['cid'] = $part->headers['content-id'];
Index: trunk/expressoMail1_2/inc/class.message_components.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.message_components.inc.php	(revision 3858)
+++ trunk/expressoMail1_2/inc/class.message_components.inc.php	(revision 5134)
@@ -105,5 +105,6 @@
 
                     $ftype        = (empty($parts[$p]->type))?           $this->data_types[0].'/'.strtolower($parts[$p]->subtype) : $this->data_types[$parts[$p]->type].'/'.strtolower($parts[$p]->subtype);
-                    $encoding     = (empty($parts[$p]->encoding))?       $this->encoding_types[0] : $this->encoding_types[$parts[$p]->encoding];
+                    $encoding     = (isset($parts[$p]->encoding) && !empty($parts[$p]->encoding) && isset($this->encoding_types[$parts[$p]->encoding]) )?      $this->encoding_types[$parts[$p]->encoding]  : $this->encoding_types[0];
+                  
                     if(!preg_match("/5./",phpversion()))
 	                    $charset      = $parts[$p]->parameters[0]->value;
Index: trunk/expressoMail1_2/inc/class.imap_attachment.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.imap_attachment.inc.php	(revision 3289)
+++ trunk/expressoMail1_2/inc/class.imap_attachment.inc.php	(revision 5134)
@@ -26,5 +26,5 @@
 		include_once("class.message_components.inc.php");
 
-		$msg =& new message_components($mbox);
+		$msg = new message_components($mbox);
 		$msg->fetch_structure($msgno);
 
@@ -50,5 +50,5 @@
 		include_once("class.message_components.inc.php");
 
-		$msg =& new message_components($mbox);
+		$msg = new message_components($mbox);
 		$msg->fetch_structure($msgno);
 		$array_parts_attachments = array();		
